Index: qemu/disas.c
===================================================================
--- qemu.orig/disas.c	2008-08-12 15:49:32.000000000 +0000
+++ qemu/disas.c	2008-08-12 16:01:12.000000000 +0000
@@ -341,11 +341,8 @@
 static CPUState *monitor_disas_env;
 
 static int
-monitor_read_memory (memaddr, myaddr, length, info)
-     bfd_vma memaddr;
-     bfd_byte *myaddr;
-     int length;
-     struct disassemble_info *info;
+monitor_read_memory (bfd_vma memaddr, bfd_byte *myaddr, int length,
+                     struct disassemble_info *info)
 {
     if (monitor_disas_is_physical) {
         cpu_physical_memory_rw(memaddr, myaddr, length, 0);
Index: qemu/hw/mips_malta.c
===================================================================
--- qemu.orig/hw/mips_malta.c	2008-08-12 15:49:32.000000000 +0000
+++ qemu/hw/mips_malta.c	2008-08-12 16:01:12.000000000 +0000
@@ -155,7 +155,7 @@
     },
 };
 
-static uint8_t eeprom24c0x_read()
+static uint8_t eeprom24c0x_read(void)
 {
     logout("%u: scl = %u, sda = %u, data = 0x%02x\n",
         eeprom.tick, eeprom.scl, eeprom.sda, eeprom.data);
Index: qemu/hw/shix.c
===================================================================
--- qemu.orig/hw/shix.c	2008-08-12 15:49:32.000000000 +0000
+++ qemu/hw/shix.c	2008-08-12 16:01:12.000000000 +0000
@@ -45,17 +45,17 @@
     /* XXXXX */
 }
 
-void pic_info()
+void pic_info(void)
 {
     /* XXXXX */
 }
 
-void vga_update_display()
+void vga_update_display(void)
 {
     /* XXXXX */
 }
 
-void vga_invalidate_display()
+void vga_invalidate_display(void)
 {
     /* XXXXX */
 }
Index: qemu/mips-dis.c
===================================================================
--- qemu.orig/mips-dis.c	2008-08-12 15:49:32.000000000 +0000
+++ qemu/mips-dis.c	2008-08-12 16:01:12.000000000 +0000
@@ -3322,9 +3322,7 @@
 }
 
 void
-parse_mips_dis_option (option, len)
-     const char *option;
-     unsigned int len;
+parse_mips_dis_option (const char *option, unsigned int len)
 {
   unsigned int i, optionlen, vallen;
   const char *val;
Index: qemu/target-alpha/translate.c
===================================================================
--- qemu.orig/target-alpha/translate.c	2008-08-12 15:49:32.000000000 +0000
+++ qemu/target-alpha/translate.c	2008-08-12 16:01:12.000000000 +0000
@@ -47,7 +47,7 @@
 
 #include "gen-icount.h"
 
-static void alpha_translate_init()
+static void alpha_translate_init(void)
 {
     static int done_init = 0;
     if (done_init)
Index: qemu/target-sh4/translate.c
===================================================================
--- qemu.orig/target-sh4/translate.c	2008-08-12 15:49:32.000000000 +0000
+++ qemu/target-sh4/translate.c	2008-08-12 16:01:12.000000000 +0000
@@ -60,7 +60,7 @@
 
 #include "gen-icount.h"
 
-static void sh4_translate_init()
+static void sh4_translate_init(void)
 {
     static int done_init = 0;
     if (done_init)
Index: qemu/monitor.c
===================================================================
--- qemu.orig/monitor.c	2008-08-12 15:49:32.000000000 +0000
+++ qemu/monitor.c	2008-08-12 16:01:12.000000000 +0000
@@ -61,7 +61,7 @@
 typedef struct term_cmd_t {
     const char *name;
     const char *args_type;
-    void (*handler)();
+    void *handler;
     const char *params;
     const char *help;
 } term_cmd_t;
@@ -224,6 +224,7 @@
 static void do_info(const char *item)
 {
     term_cmd_t *cmd;
+    void (*handler)(void);
 
     if (!item)
         goto help;
@@ -235,7 +236,8 @@
     help_cmd("info");
     return;
  found:
-    cmd->handler();
+    handler = cmd->handler;
+    handler();
 }
 
 static void do_info_version(void)
@@ -2156,6 +2158,17 @@
     char buf[1024];
     void *str_allocated[MAX_ARGS];
     void *args[MAX_ARGS];
+    void (*handler_0)(void);
+    void (*handler_1)(void *arg0);
+    void (*handler_2)(void *arg0, void *arg1);
+    void (*handler_3)(void *arg0, void *arg1, void *arg2);
+    void (*handler_4)(void *arg0, void *arg1, void *arg2, void *arg3);
+    void (*handler_5)(void *arg0, void *arg1, void *arg2, void *arg3,
+                      void *arg4);
+    void (*handler_6)(void *arg0, void *arg1, void *arg2, void *arg3,
+                      void *arg4, void *arg5);
+    void (*handler_7)(void *arg0, void *arg1, void *arg2, void *arg3,
+                      void *arg4, void *arg5, void *arg6);
 
 #ifdef DEBUG
     term_printf("command='%s'\n", cmdline);
@@ -2418,28 +2431,36 @@
 
     switch(nb_args) {
     case 0:
-        cmd->handler();
+        handler_0 = cmd->handler;
+        handler_0();
         break;
     case 1:
-        cmd->handler(args[0]);
+        handler_1 = cmd->handler;
+        handler_1(args[0]);
         break;
     case 2:
-        cmd->handler(args[0], args[1]);
+        handler_2 = cmd->handler;
+        handler_2(args[0], args[1]);
         break;
     case 3:
-        cmd->handler(args[0], args[1], args[2]);
+        handler_3 = cmd->handler;
+        handler_3(args[0], args[1], args[2]);
         break;
     case 4:
-        cmd->handler(args[0], args[1], args[2], args[3]);
+        handler_4 = cmd->handler;
+        handler_4(args[0], args[1], args[2], args[3]);
         break;
     case 5:
-        cmd->handler(args[0], args[1], args[2], args[3], args[4]);
+        handler_5 = cmd->handler;
+        handler_5(args[0], args[1], args[2], args[3], args[4]);
         break;
     case 6:
-        cmd->handler(args[0], args[1], args[2], args[3], args[4], args[5]);
+        handler_6 = cmd->handler;
+        handler_6(args[0], args[1], args[2], args[3], args[4], args[5]);
         break;
     case 7:
-        cmd->handler(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
+        handler_7 = cmd->handler;
+        handler_7(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
         break;
     default:
         term_printf("unsupported number of arguments: %d\n", nb_args);
Index: qemu/slirp/if.c
===================================================================
--- qemu.orig/slirp/if.c	2008-08-12 15:49:32.000000000 +0000
+++ qemu/slirp/if.c	2008-08-12 16:01:12.000000000 +0000
@@ -16,8 +16,7 @@
 #define ifs_init(ifm) ((ifm)->ifs_next = (ifm)->ifs_prev = (ifm))
 
 void
-ifs_insque(ifm, ifmhead)
-	struct mbuf *ifm, *ifmhead;
+ifs_insque(struct mbuf *ifm, struct mbuf *ifmhead)
 {
 	ifm->ifs_next = ifmhead->ifs_next;
 	ifmhead->ifs_next = ifm;
@@ -26,8 +25,7 @@
 }
 
 void
-ifs_remque(ifm)
-	struct mbuf *ifm;
+ifs_remque(struct mbuf *ifm)
 {
 	ifm->ifs_prev->ifs_next = ifm->ifs_next;
 	ifm->ifs_next->ifs_prev = ifm->ifs_prev;
